OGRE: Ogre::RenderTarget Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RenderTarget Class Referenceabstract
Core » RenderSystem

A 'canvas' which can receive the results of a rendering operation. More...

`#include <OgreRenderTarget.h>`

Inheritance diagram for Ogre::RenderTarget:
[legend]

## Classes
struct | FrameStats

## Public Types
enum | FrameBuffer { FB_FRONT , FB_BACK , FB_AUTO }

## Public Member Functions
| RenderTarget ()
virtual | ~RenderTarget ()
virtual void | _beginUpdate ()
| Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.
virtual void | _detachDepthBuffer ()
| Detaches DepthBuffer without notifying it from the detach.
virtual void | _endUpdate ()
| Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.
void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify a render target that a camera has been removed, in case it was referring to it as a viewer.
void | _updateAutoUpdatedViewports (bool updateStatistics=true)
| Method for manual management of rendering - renders only viewports that are auto updated.
void | _updateViewport (int zorder, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
virtual void | _updateViewport (Viewport *viewport, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
void | addListener (RenderTargetListener *listener)
| Add a listener to this RenderTarget which will be called back before & after rendering.
Viewport * | addViewport (Camera *cam, int ZOrder, float left, float top=0.0f, float width=1.0f, float height=1.0f)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Viewport * | addViewport (Camera *cam, int ZOrder=0, FloatRect rect={0.0f, 0.0f, 1.0f, 1.0f})
| Adds a viewport to the rendering target.
virtual bool | attachDepthBuffer (DepthBuffer *depthBuffer)
virtual void | copyContentsToMemory (const Box &src, const PixelBox &dst, FrameBuffer buffer=FB_AUTO)=0
| Copies the current contents of the render target to a pixelbox.
void | copyContentsToMemory (const PixelBox &dst, FrameBuffer buffer=FB_AUTO)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | detachDepthBuffer ()
uint | getCustomAttribute (const String &name)
| simplified API for bindings
virtual void | getCustomAttribute (const String &name, void *pData)
| Retrieve a platform or API-specific piece of information.
DepthBuffer * | getDepthBuffer () const
uint16 | getDepthBufferPool () const
uint | getFSAA () const
| Indicates whether multisampling is performed on rendering and at what level.
const String & | getFSAAHint () const
| RenderSystem specific FSAA option. See RenderSystem::_createRenderWindow for details.
uint32 | getHeight (void) const
void | getMetrics (unsigned int &width, unsigned int &height)
| Retrieve information about the render target.
const String & | getName (void) const
| Retrieve target's name.
unsigned short | getNumViewports (void) const
| Returns the number of viewports attached to this target.
uchar | getPriority () const
| Gets the priority of a render target.
const FrameStats & | getStatistics (void) const
| Retrieves details of current rendering performance.
Viewport * | getViewport (unsigned short index)
| Retrieves a pointer to the viewport with the given index.
Viewport * | getViewportByZOrder (int ZOrder)
| Retrieves a pointer to the viewport with the given Z-order.
uint32 | getWidth (void) const
bool | hasViewportWithZOrder (int ZOrder)
| Returns true if and only if a viewport exists at the given Z-order.
void | insertListener (RenderTargetListener *listener, const unsigned int pos=0)
| same as addListener, but force the position in the vector, so we can control the call order
virtual bool | isActive () const
| Used to retrieve or set the active state of the render target.
bool | isAutoUpdated (void) const
| Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
bool | isHardwareGammaEnabled () const
| Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.
virtual bool | isPrimary (void) const
| Indicates whether this target is the primary window.
virtual bool | isStereoEnabled (void) const
| Indicates whether stereo is currently enabled for this target.
void | removeAllListeners (void)
| Removes all listeners from this instance.
void | removeAllViewports (void)
| Removes all viewports on this target.
void | removeListener (RenderTargetListener *listener)
| Removes a RenderTargetListener previously registered using addListener.
void | removeViewport (int ZOrder)
| Removes a viewport at a given Z-order.
virtual bool | requiresTextureFlipping () const =0
void | resetStatistics (void)
| Resets saved frame-rate statistices.
void | setActive (bool state)
| Used to set the active state of the render target.
void | setAutoUpdated (bool autoupdate)
| Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
void | setDepthBufferPool (uint16 poolId)
| Sets the pool ID this RenderTarget should query from.
virtual void | setFSAA (uint fsaa, const String &fsaaHint)
| Set the level of multisample AA to be used if hardware support it.
void | setPriority (uchar priority)
| Sets the priority of this render target in relation to the others.
virtual PixelFormat | suggestPixelFormat () const
| Suggests a pixel format to use for extracting the data in this target, when calling copyContentsToMemory.
virtual void | swapBuffers ()
| Finalizes the frame by performing buffer swaps and MSAA resolves.
void | update (bool swapBuffers=true)
| Tells the target to update it's contents.
void | writeContentsToFile (const String &filename)
| Writes the current contents of the render target to the named file.
String | writeContentsToTimestampedFile (const String &filenamePrefix, const String &filenameSuffix)
| Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

## Detailed Description

A 'canvas' which can receive the results of a rendering operation.

This abstract class defines a common root to all targets of rendering operations. A render target could be a window on a screen, or another offscreen surface like a texture or bump map etc.

Author
  Steven Streeting

## Member Enumeration Documentation

## ◆ FrameBuffer

enum Ogre::RenderTarget::FrameBuffer

Enumerator
FB_FRONT |
FB_BACK |
FB_AUTO |

## Constructor & Destructor Documentation

## ◆ RenderTarget()

Ogre::RenderTarget::RenderTarget | ( |  | ) |

## ◆ ~RenderTarget()

virtual Ogre::RenderTarget::~RenderTarget | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getName()

const String & Ogre::RenderTarget::getName | ( | void |  | ) | const
| inline

Retrieve target's name.

## ◆ getMetrics()

void Ogre::RenderTarget::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height )

Retrieve information about the render target.

## ◆ getWidth()

uint32 Ogre::RenderTarget::getWidth | ( | void |  | ) | const
| inline

## ◆ getHeight()

uint32 Ogre::RenderTarget::getHeight | ( | void |  | ) | const
| inline

## ◆ setDepthBufferPool()

void Ogre::RenderTarget::setDepthBufferPool | ( | uint16 | poolId | ) |

Sets the pool ID this RenderTarget should query from.

Default value is POOL_DEFAULT. Set to POOL_NO_DEPTH to avoid using a DepthBuffer (or manually controlling it)

See also
  DepthBuffer Changing the pool Id will cause the current depth buffer to be detached unless the old id and the new one are the same

## ◆ getDepthBufferPool()

uint16 Ogre::RenderTarget::getDepthBufferPool | ( |  | ) | const
| inline

## ◆ getDepthBuffer()

DepthBuffer * Ogre::RenderTarget::getDepthBuffer | ( |  | ) | const
| inline

## ◆ attachDepthBuffer()

virtual bool Ogre::RenderTarget::attachDepthBuffer | ( | DepthBuffer * | depthBuffer | ) |
| virtual

## ◆ detachDepthBuffer()

void Ogre::RenderTarget::detachDepthBuffer | ( |  | ) |

## ◆ _detachDepthBuffer()

virtual void Ogre::RenderTarget::_detachDepthBuffer | ( |  | ) |
| inlinevirtual

Detaches DepthBuffer without notifying it from the detach.

Useful when called from the DepthBuffer while it iterates through attached RenderTargets (

See also
  DepthBuffer::_setPoolId())

## ◆ update()

void Ogre::RenderTarget::update | ( | bool | swapBuffers = true | ) |

Tells the target to update it's contents.

If OGRE is not running in an automatic rendering loop (via Root::startRendering), the user of the library is responsible for asking each render target to refresh. This is the method used to do this. It automatically re-renders the contents of the target using whatever cameras have been pointed at it (using addViewport).

This allows OGRE to be used in multi-windowed utilities and for contents to be refreshed only when required, rather than constantly as with the automatic rendering loop.

Parameters

  swapBuffers | If set to true, the target will immediately call swapBuffers() after the update. See swapBuffers() for why you might want to set this to false.

References swapBuffers().

## ◆ swapBuffers()

virtual void Ogre::RenderTarget::swapBuffers | ( |  | ) |
| inlinevirtual

Finalizes the frame by performing buffer swaps and MSAA resolves.

This method handles the end-of-frame operations required to display the rendered content. Depending on the target configuration, this includes:

- Swapping the front and back buffers (if double-buffering is enabled).
- Resolving the MSAA (Multisample Anti-Aliasing) surface to the displayable surface (if MSAA is enabled).

Attention
  After this method returns, the contents of the multisample buffers are invalidated/discarded. You cannot rely on their contents for subsequent operations without re-rendering.

Referenced by update().

## ◆ addViewport() [1/2]

Viewport * Ogre::RenderTarget::addViewport | ( | Camera * | cam,
|  | int | ZOrder = 0,
|  | FloatRect | rect = {0.0f, 0.0f, 1.0f, 1.0f} )

Adds a viewport to the rendering target.

A viewport is the rectangle into which rendering output is sent. This method adds a viewport to the render target, rendering from the supplied camera. The rest of the parameters are only required if you wish to add more than one viewport to a single rendering target. Note that size information passed to this method is passed as a parametric, i.e. it is relative rather than absolute. This is to allow viewports to automatically resize along with the target.

Parameters

  cam | The camera from which the viewport contents will be rendered (mandatory)
  ZOrder | The relative order of the viewport with others on the target (allows overlapping viewports i.e. picture-in-picture). Higher Z-orders are on top of lower ones. The actual number is irrelevant, only the relative Z-order matters (you can leave gaps in the numbering)
  rect | The relative position of the viewport on the target, as a value between 0 and 1.

Referenced by addViewport().

## ◆ addViewport() [2/2]

Viewport * Ogre::RenderTarget::addViewport | ( | Camera * | cam,
|  | int | ZOrder,
|  | float | left,
|  | float | top = 0.0f,
|  | float | width = 1.0f,
|  | float | height = 1.0f )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References addViewport().

## ◆ getNumViewports()

unsigned short Ogre::RenderTarget::getNumViewports | ( | void |  | ) | const
| inline

Returns the number of viewports attached to this target.

## ◆ getViewport()

Viewport * Ogre::RenderTarget::getViewport | ( | unsigned short | index | ) |

Retrieves a pointer to the viewport with the given index.

## ◆ getViewportByZOrder()

Viewport * Ogre::RenderTarget::getViewportByZOrder | ( | int | ZOrder | ) |

Retrieves a pointer to the viewport with the given Z-order.

Remarks
  throws if not found.

Referenced by _updateViewport().

## ◆ hasViewportWithZOrder()

bool Ogre::RenderTarget::hasViewportWithZOrder | ( | int | ZOrder | ) |

Returns true if and only if a viewport exists at the given Z-order.

## ◆ removeViewport()

void Ogre::RenderTarget::removeViewport | ( | int | ZOrder | ) |

Removes a viewport at a given Z-order.

## ◆ removeAllViewports()

void Ogre::RenderTarget::removeAllViewports | ( | void |  | ) |

Removes all viewports on this target.

## ◆ getStatistics()

const FrameStats & Ogre::RenderTarget::getStatistics | ( | void |  | ) | const
| inline

Retrieves details of current rendering performance.

## ◆ resetStatistics()

void Ogre::RenderTarget::resetStatistics | ( | void |  | ) |

Resets saved frame-rate statistices.

## ◆ getCustomAttribute() [1/2]

virtual void Ogre::RenderTarget::getCustomAttribute | ( | const String & | name,
|  | void * | pData )
| virtual

Retrieve a platform or API-specific piece of information.

This method of retrieving information should only be used if you know what you're doing.

Name | Description
--- | ---
WINDOW | The native window handle. (X11 Window XID/ HWND / NSWindow*)
HWND | deprecated (same as WINDOW)
GL_FBOID | the id of the OpenGL framebuffer object
GL_MULTISAMPLEFBOID | the id of the OpenGL framebuffer object used for multisampling
GLFBO | id of the screen OpenGL framebuffer object on iOS
GLCONTEXT | deprecated, do not use
FBO | deprecated, do not use
TARGET | deprecated, do not use
XDISPLAY | The X Display connection behind that context.
ATOM | The X Atom used in client delete events.
VIEW | Cocoa NSView*
NSOPENGLCONTEXT | Cocoa NSOpenGLContext*
NSOPENGLPIXELFORMAT | Cocoa NSOpenGLPixelFormat*

Parameters

  name | The name of the attribute.
  pData | Pointer to memory of the right kind of structure to receive the info.

Referenced by getCustomAttribute().

## ◆ getCustomAttribute() [2/2]

uint Ogre::RenderTarget::getCustomAttribute | ( | const String & | name | ) |
| inline

simplified API for bindings

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References getCustomAttribute().

## ◆ addListener()

void Ogre::RenderTarget::addListener | ( | RenderTargetListener * | listener | ) |

Add a listener to this RenderTarget which will be called back before & after rendering.

If you want notifications before and after a target is updated by the system, use this method to register your own custom RenderTargetListener class. This is useful for potentially adding your own manual rendering commands before and after the 'normal' system rendering.

NB this should not be used for frame-based scene updates, use Root::addFrameListener for that.

## ◆ insertListener()

void Ogre::RenderTarget::insertListener | ( | RenderTargetListener * | listener,
|  | const unsigned int | pos = 0 )

same as addListener, but force the position in the vector, so we can control the call order

## ◆ removeListener()

void Ogre::RenderTarget::removeListener | ( | RenderTargetListener * | listener | ) |

Removes a RenderTargetListener previously registered using addListener.

## ◆ removeAllListeners()

void Ogre::RenderTarget::removeAllListeners | ( | void |  | ) |

Removes all listeners from this instance.

## ◆ setPriority()

void Ogre::RenderTarget::setPriority | ( | uchar | priority | ) |
| inline

Sets the priority of this render target in relation to the others.

This can be used in order to schedule render target updates. Lower priorities will be rendered first. Note that the priority must be set at the time the render target is attached to the render system, changes afterwards will not affect the ordering.

## ◆ getPriority()

uchar Ogre::RenderTarget::getPriority | ( |  | ) | const
| inline

Gets the priority of a render target.

## ◆ isActive()

virtual bool Ogre::RenderTarget::isActive | ( | void |  | ) | const
| inlinevirtual

Used to retrieve or set the active state of the render target.

Reimplemented in Ogre::RenderWindow.

## ◆ setActive()

void Ogre::RenderTarget::setActive | ( | bool | state | ) |
| inline

Used to set the active state of the render target.

## ◆ setAutoUpdated()

void Ogre::RenderTarget::setAutoUpdated | ( | bool | autoupdate | ) |
| inline

Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

By default, if you use Ogre's own rendering loop (Root::startRendering) or call Root::_updateAllRenderTargets, all render targets are updated automatically. This method allows you to control that behaviour, if for example you have a render target which you only want to update periodically.

Parameters

  autoupdate | If true, the render target is updated during the automatic render loop or when Root::_updateAllRenderTargets is called. If false, the target is only updated when its update() method is called explicitly.

## ◆ isAutoUpdated()

bool Ogre::RenderTarget::isAutoUpdated | ( | void |  | ) | const
| inline

Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

## ◆ copyContentsToMemory() [1/2]

virtual void Ogre::RenderTarget::copyContentsToMemory | ( | const Box & | src,
|  | const PixelBox & | dst,
|  | FrameBuffer | buffer = FB_AUTO )
| pure virtual

Copies the current contents of the render target to a pixelbox.

Remarks
  See suggestPixelFormat for a tip as to the best pixel format to extract into, although you can use whatever format you like and the results will be converted.

Implemented in Ogre::MultiRenderTarget, and Ogre::RenderTexture.

References FB_AUTO.

Referenced by Ogre::RenderTexture::~RenderTexture().

## ◆ copyContentsToMemory() [2/2]

void Ogre::RenderTarget::copyContentsToMemory | ( | const PixelBox & | dst,
|  | FrameBuffer | buffer = FB_AUTO )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  This function is deprecated as behavior for dst.size < RenderTarget.size was inconsistent in previous versions of Ogre. Sometimes the whole rect was used as a source, sometimes the rect with the size equal to the size of destination rect but located in the top left corner of the render target, sometimes the destination rect itself. Use the overload with explicitly specified source and destination boxes instead.

References copyContentsToMemory(), and FB_AUTO.

Referenced by copyContentsToMemory().

## ◆ suggestPixelFormat()

virtual PixelFormat Ogre::RenderTarget::suggestPixelFormat | ( |  | ) | const
| inlinevirtual

Suggests a pixel format to use for extracting the data in this target, when calling copyContentsToMemory.

Reimplemented in Ogre::MultiRenderTarget, Ogre::RenderTexture, and Ogre::RenderWindow.

References Ogre::PF_BYTE_RGBA.

## ◆ writeContentsToFile()

void Ogre::RenderTarget::writeContentsToFile | ( | const String & | filename | ) |

Writes the current contents of the render target to the named file.

## ◆ writeContentsToTimestampedFile()

String Ogre::RenderTarget::writeContentsToTimestampedFile | ( | const String & | filenamePrefix,
|  | const String & | filenameSuffix )

Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

Returns
  the name of the file used.

## ◆ requiresTextureFlipping()

virtual bool Ogre::RenderTarget::requiresTextureFlipping | ( |  | ) | const
| pure virtual

## ◆ _notifyCameraRemoved()

void Ogre::RenderTarget::_notifyCameraRemoved | ( | const Camera * | cam | ) |

Utility method to notify a render target that a camera has been removed, in case it was referring to it as a viewer.

## ◆ isPrimary()

virtual bool Ogre::RenderTarget::isPrimary | ( | void |  | ) | const
| inlinevirtual

Indicates whether this target is the primary window.

The primary window is special in that it is destroyed when ogre is shut down, and cannot be destroyed directly. This is the case because it holds the context for vertex, index buffers and textures.

Reimplemented in Ogre::RenderWindow.

## ◆ isStereoEnabled()

virtual bool Ogre::RenderTarget::isStereoEnabled | ( | void |  | ) | const
| inlinevirtual

Indicates whether stereo is currently enabled for this target.

Default is false.

## ◆ isHardwareGammaEnabled()

bool Ogre::RenderTarget::isHardwareGammaEnabled | ( |  | ) | const
| inline

Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.

This is the exact opposite conversion of what is indicated by Texture::isHardwareGammaEnabled, and can only be enabled on creation of the render target. For render windows, it's enabled through the 'gamma' creation misc parameter. For textures, it is enabled through the hwGamma parameter to the create call.

## ◆ getFSAA()

uint Ogre::RenderTarget::getFSAA | ( |  | ) | const
| inline

Indicates whether multisampling is performed on rendering and at what level.

## ◆ getFSAAHint()

const String & Ogre::RenderTarget::getFSAAHint | ( |  | ) | const
| inline

RenderSystem specific FSAA option. See RenderSystem::_createRenderWindow for details.

## ◆ setFSAA()

virtual void Ogre::RenderTarget::setFSAA | ( | uint | fsaa,
|  | const String & | fsaaHint )
| inlinevirtual

Set the level of multisample AA to be used if hardware support it.

This option will be ignored if the hardware does not support it or setting can not be changed on the fly on per-target level.

Parameters

  fsaa | The number of samples
  fsaaHint | RenderSystem specific FSAA option. See RenderSystem::_createRenderWindow for details.

## ◆ _beginUpdate()

virtual void Ogre::RenderTarget::_beginUpdate | ( |  | ) |
| virtual

Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.

- _beginUpdate resets statistics and fires 'preRenderTargetUpdate'.
- _updateViewport renders the given viewport (even if it is not autoupdated), fires preViewportUpdate and postViewportUpdate and manages statistics.
- _updateAutoUpdatedViewports renders only viewports that are auto updated, fires preViewportUpdate and postViewportUpdate and manages statistics.
- _endUpdate() ends statistics calculation and fires postRenderTargetUpdate.

you can use it like this for example :

        renderTarget->_beginUpdate();
        renderTarget->_updateViewport(1); // which is not auto updated
        renderTarget->_updateViewport(2); // which is not auto updated
        renderTarget->_updateAutoUpdatedViewports();
        renderTarget->_endUpdate();
        renderTarget->swapBuffers();

Please note that in that case, the zorder may not work as you expect, since you are responsible for calling _updateViewport in the correct order.

## ◆ _updateViewport() [1/2]

void Ogre::RenderTarget::_updateViewport | ( | int | zorder,
|  | bool | updateStatistics = true )
| inline

Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).

This also fires preViewportUpdate and postViewportUpdate, and manages statistics. You should call it between _beginUpdate() and _endUpdate().

See also
  _beginUpdate for more details.

Parameters

  zorder | The zorder of the viewport to update.
  updateStatistics | Whether you want to update statistics or not.

References _updateViewport(), and getViewportByZOrder().

Referenced by _updateViewport().

## ◆ _updateViewport() [2/2]

virtual void Ogre::RenderTarget::_updateViewport | ( | Viewport * | viewport,
|  | bool | updateStatistics = true )
| virtual

Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).

This also fires preViewportUpdate and postViewportUpdate, and manages statistics if needed. You should call it between _beginUpdate() and _endUpdate().

See also
  _beginUpdate for more details.

Parameters

  viewport | The viewport you want to update, it must be bound to the rendertarget.
  updateStatistics | Whether you want to update statistics or not.

## ◆ _updateAutoUpdatedViewports()

void Ogre::RenderTarget::_updateAutoUpdatedViewports | ( | bool | updateStatistics = true | ) |

Method for manual management of rendering - renders only viewports that are auto updated.

This also fires preViewportUpdate and postViewportUpdate, and manages statistics. You should call it between _beginUpdate() and _endUpdate(). See _beginUpdate for more details.

Parameters

  updateStatistics | Whether you want to update statistics or not.

See also
  _beginUpdate()

## ◆ _endUpdate()

virtual void Ogre::RenderTarget::_endUpdate | ( |  | ) |
| virtual

Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.

You should call it after a _beginUpdate

See also
  _beginUpdate for more details.

The documentation for this class was generated from the following file:

- OgreRenderTarget.h